
import flyd from 'flyd'

// Stream that counts from zero up to max in intervals
const timer = (maxMs, intervalMs) => {
  if(maxMs <= intervalMs) throw "Pass in maximum ms and interval ms"
  const s = flyd.stream(0)
  let target = Date.now() + intervalMs
  const fn = () => {
    const now = Date.now()
    if (s.end()) return;
    target += intervalMs
    const count = (s()||0) + intervalMs
    s(count)
    if(count < maxMs) setTimeout(fn, target - now)
    else s.end(true)
  }
  setTimeout(fn, target - Date.now())
  return s
}

module.exports = timer
