"use strict";

var _flyd = require("flyd");

var _flyd2 = _interopRequireDefault(_flyd);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Stream that counts from zero up to max in intervals
var timer = function timer(maxMs, intervalMs) {
  if (maxMs <= intervalMs) throw "Pass in maximum ms and interval ms";
  var s = _flyd2.default.stream(0);
  var target = Date.now() + intervalMs;
  var fn = function fn() {
    var now = Date.now();
    if (s.end()) return;
    target += intervalMs;
    var count = (s() || 0) + intervalMs;
    s(count);
    if (count < maxMs) setTimeout(fn, target - now);else s.end(true);
  };
  setTimeout(fn, target - Date.now());
  return s;
};

module.exports = timer;

