import flyd from 'flyd'
import assert from 'assert'
import flyd_afterSilence from 'flyd/module/aftersilence'
import timer from '../index.es6'

suite('flyd-timer')

test('initializes stream with 0', ()=> {
  const s = timer(2000, 1000)
  assert.equal(s(), 0)
})

test('count from 0 to 100 inclusive', done => {
  const s = timer(100, 10)
  const arr = flyd_afterSilence(150, s)
  setTimeout(() => {
    console.log(s(), arr(), s, arr)
    assert.deepEqual(arr(), [0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100])
    done()
  }, 500)
})

test('throws if max is lte interval', () => {
  assert.throws(() => timer(10, 100))
})

